using System; 
using System.Security.Cryptography; 
using System.Text; 

public class MD5HashHelper 
{ 

	public byte[] GetHash(string message) 
	{ 
		byte[] data; 
		data = UTF8Encoding.ASCII.GetBytes(message); 
		MD5CryptoServiceProvider md5 = new MD5CryptoServiceProvider(); 
		return md5.ComputeHash(data, 0, data.Length); 
	} 

	public bool VerifyHash(string message, byte[] hash) 
	{ 
		byte[] data; 
		data = UTF8Encoding.ASCII.GetBytes(message); 
		MD5CryptoServiceProvider md5 = new MD5CryptoServiceProvider(); 
		byte[] hashTemp = md5.ComputeHash(data, 0, data.Length); 

		for (Int32 counter = 0; counter <= hash.Length - 1; counter += 1) 
		{
			if (hash[counter] != hashTemp[counter]) 
			{ 
				return false; 
			} 
		} 
		return true; 
	} 
}

public class DigitalSignatureHelper 
{ 
	private RSAParameters m_public; 

	public byte[] CreateSignature(byte[] hash) 
	{ 
		RSACryptoServiceProvider RSA = new RSACryptoServiceProvider(); 
		RSAPKCS1SignatureFormatter RSAFormatter = new RSAPKCS1SignatureFormatter(RSA); 
		RSAFormatter.SetHashAlgorithm("MD5"); 
		m_public = RSA.ExportParameters(false); 
		return RSAFormatter.CreateSignature(hash); 
	} 

	public bool VerifySignature(byte[] hash, byte[] signedhash) 
	{ 
		RSACryptoServiceProvider RSA = new RSACryptoServiceProvider(); 
		RSAParameters RSAKeyInfo = new RSAParameters(); 
		RSAKeyInfo.Modulus = m_public.Modulus; 
		RSAKeyInfo.Exponent = m_public.Exponent; 
		RSA.ImportParameters(RSAKeyInfo); 
		RSAPKCS1SignatureDeformatter RSADeformatter = new RSAPKCS1SignatureDeformatter(RSA); 
		RSADeformatter.SetHashAlgorithm("MD5"); 
		return RSADeformatter.VerifySignature(hash, signedhash); 
	} 
}
